Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## groovy.jmx.builder
[Groovy] Class JmxMetaMapBuilder

    java.lang.Object
      groovy.jmx.builder.JmxMetaMapBuilder

    class JmxMetaMapBuilder

The JmxMetaMapBuilder class is used to collect meta data passed in JmxBuilder nodes. Once collected, the data is then normalized to be represented uniformly regardless of the resource where it was obtained.

Authors:
  Vladimir Vivien

Method Summary
`static java.util.Map` | `buildAttributeMapFrom(java.lang.Object object)` Builds attribute meta map with default information from an instance of an object.
`static java.util.Map` | `buildAttributeMapFrom(java.lang.Object object, java.lang.Object descCollection)` Sanitizes and builds an attribute meta map from a descriptor collection.
`static java.util.Map` | `buildConstructorMapFrom(java.lang.Object object)` Returns a meta map of constructors from given object.
`static java.util.Map` | `buildConstructorMapFrom(java.lang.Object object, java.lang.Object descCollection)` Builds a fully normalized constructor meta map.
`static java.lang.Object` | `buildListenerMapFrom(java.lang.Object descCollection)` Creates a fully-normalized meta map for agiven collection of listeners.
`static java.util.Map` | `buildObjectMapFrom(java.lang.Object object)` Builds a complete meta map graph for the specified object using default values.
`static java.util.Map` | `buildObjectMapFrom(java.lang.Object object, java.lang.Object descriptor)` Builds a complete meta map graph for a given target and descriptor.
`static java.util.Map` | `buildOperationMapFrom(java.lang.Object object)` Returns a meta map of operations from given object.
`static java.util.Map` | `buildOperationMapFrom(java.lang.Object object, java.lang.Object descCollection)`
`static java.util.Map` | `buildParameterMapFrom(java.lang.Object method)` Builds a normalized parameter meta map for all params on provided method.
`static java.util.Map` | `buildParameterMapFrom(java.lang.Object method, java.lang.Object descCollection)` Builds a fully normalized parameter meta map for the method and the given meta map.
`static java.util.Map` | `createListenerMap(java.lang.Object descriptor)` Builds normalized meta map of the provided listener descriptor.

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Method Detail

### buildAttributeMapFrom

    static java.util.Map buildAttributeMapFrom(java.lang.Object object)

  Builds attribute meta map with default information from an instance of an object.
  Parameters:
    `the` - object from which attribute info will be retrieved
  Returns:
    the meta map for the attribute

### buildAttributeMapFrom

    static java.util.Map buildAttributeMapFrom(java.lang.Object object, java.lang.Object descCollection)

  Sanitizes and builds an attribute meta map from a descriptor collection. The collection can either be a map of the form [attribName:[descriptor...],...] or [attribName1,...attribNameN]. The code guests sensible defaults when values are not provided
  Parameters:
    `the` - object about which meta data is collected
    `descriptor` - collection: either a map or a list
  Returns:
    a Map of meta information about the object.

### buildConstructorMapFrom

    static java.util.Map buildConstructorMapFrom(java.lang.Object object)

  Returns a meta map of constructors from given object.
  Parameters:
    `object` - to profile
  Returns:
    The meta map generated.

### buildConstructorMapFrom

    static java.util.Map buildConstructorMapFrom(java.lang.Object object, java.lang.Object descCollection)

  Builds a fully normalized constructor meta map.
  Parameters:
    `the` - object where constructor is defined.
    `the` - meta map that will be normalized
  Returns:
    a normalized meta map for the constructor

### buildListenerMapFrom

    static java.lang.Object buildListenerMapFrom(java.lang.Object descCollection)

  Creates a fully-normalized meta map for agiven collection of listeners.
  Parameters:
    `-` - collection of descriptors to normalize
  See Also:
    JmxMetaMapBuilder#createListenerMap(Object)#createListenerMap(Object)

### buildObjectMapFrom

    static java.util.Map buildObjectMapFrom(java.lang.Object object)

  Builds a complete meta map graph for the specified object using default values. All generated attributes are set to read-only.
  Parameters:
    `object` - used to build meta data graph
  Returns:
    fully-realized meta map of the object
  See Also:
    buildAttributeMapFrom(Object)
    buildConstructorMapFrom(Object)
    buildOperationMapFrom(Object)

### buildObjectMapFrom

    static java.util.Map buildObjectMapFrom(java.lang.Object object, java.lang.Object descriptor)

  Builds a complete meta map graph for a given target and descriptor.
  Parameters:
    `object` - used to build meta data graph
    `descriptor` - a full descriptor map describing object attributes and ops.
  Returns:
    fully-realized meta map of the object
  See Also:
    buildAttributeMapFrom(Object, Map)
    buildConstructorMapFrom(Object, Map)
    buildOperationMapFrom(Object, Map)

### buildOperationMapFrom

    static java.util.Map buildOperationMapFrom(java.lang.Object object)

  Returns a meta map of operations from given object.
  Parameters:
    `object` - to profile
  Returns:
    The meta map generated.

### buildOperationMapFrom

    static java.util.Map buildOperationMapFrom(java.lang.Object object, java.lang.Object descCollection)

### buildParameterMapFrom

    static java.util.Map buildParameterMapFrom(java.lang.Object method)

  Builds a normalized parameter meta map for all params on provided method.
  Parameters:
    `the` - method with parameters to normalized
  Returns:
    the normalized map

### buildParameterMapFrom

    static java.util.Map buildParameterMapFrom(java.lang.Object method, java.lang.Object descCollection)

  Builds a fully normalized parameter meta map for the method and the given meta map.
  Parameters:
    `the` - method from which to extract normalized info.
    `a` - given meta map which will be normalized
  Returns:
    the normalized map

### createListenerMap

    static java.util.Map createListenerMap(java.lang.Object descriptor)

  Builds normalized meta map of the provided listener descriptor.
  Parameters:
    `descriptor` - - descriptive data collected from JmxBuilder listener nodes.
  Returns:
    - fully normalized meta map of listener data.

Groovy Documentation